## pybind11 2.0.0%7erc1

=== CMakeLists.txt ===
# CMakeLists.txt -- Build system for the pybind11 modules
#
# Copyright (c) 2015 Wenzel Jakob <wenzel@inf.ethz.ch>
#
# All rights reserved. Use of this source code is governed by a
# BSD-style license that can be found in the LICENSE file.

cmake_minimum_required(VERSION 2.8.12)

project(pybind11)

# Check if pybind11 is being used directly or via add_subdirectory
set(PYBIND11_MASTER_PROJECT OFF)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(PYBIND11_MASTER_PROJECT ON)
endif()

option(PYBIND11_INSTALL "Install pybind11 header files?" ${PYBIND11_MASTER_PROJECT})
option(PYBIND11_TEST    "Build pybind11 test suite?"     ${PYBIND11_MASTER_PROJECT})
option(PYBIND11_WERROR  "Report all warnings as errors"  OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/tools")

include(pybind11Tools)

# Cache variables so pybind11_add_module can be used in parent projects
set(PYBIND11_INCLUDE_DIR "${CMAKE_CURRENT_LIST_DIR}/include" CACHE INTERNAL "")
set(PYTHON_INCLUDE_DIRS ${PYTHON_INCLUDE_DIRS} CACHE INTERNAL "")
set(PYTHON_LIBRARIES ${PYTHON_LIBRARIES} CACHE INTERNAL "")
set(PYTHON_MODULE_PREFIX ${PYTHON_MODULE_PREFIX} CACHE INTERNAL "")
set(PYTHON_MODULE_EXTENSION ${PYTHON_MODULE_EXTENSION} CACHE INTERNAL "")

# Compile with compiler warnings turned on
function(pybind11_enable_warnings target_name)
  if(MSVC)
    target_compile_options(${target_name} PRIVATE /W4)
  else()
    target_compile_options(${target_name} PRIVATE -Wall -Wextra -Wconversion)
  endif()

  if(PYBIND11_WERROR)
    if(MSVC)
      target_compile_options(${target_name} PRIVATE /WX)
    else()
      target_compile_options(${target_name} PRIVATE -Werror)
    endif()
  endif()
endfunction()

set(PYBIND11_HEADERS
  include/pybind11/attr.h
  include/pybind11/cast.h
  include/pybind11/chrono.h
  include/pybind11/common.h
  include/pybind11/complex.h
  include/pybind11/descr.h
  include/pybind11/options.h
  include/pybind11/eigen.h
  include/pybind11/eval.h
  include/pybind11/functional.h
  include/pybind11/numpy.h
  include/pybind11/operators.h
  include/pybind11/pybind11.h
  include/pybind11/pytypes.h
  include/pybind11/stl.h
  include/pybind11/stl_bind.h
  include/pybind11/typeid.h
)
string(REPLACE "include/" "${CMAKE_CURRENT_SOURCE_DIR}/include/"
       PYBIND11_HEADERS "${PYBIND11_HEADERS}")

if (PYBIND11_TEST)
  add_subdirectory(tests)
endif()

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

# extract project version from source
file(STRINGS "${PYBIND11_INCLUDE_DIR}/pybind11/common.h" pybind11_version_defines
     REGEX "#define PYBIND11_VERSION_(MAJOR|MINOR|PATCH) ")
foreach(ver ${pybind11_version_defines})
  if (ver MATCHES "#define PYBIND11_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
    set(PYBIND11_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
  endif()
endforeach()
set(${PROJECT_NAME}_VERSION ${PYBIND11_VERSION_MAJOR}.${PYBIND11_VERSION_MINOR}.${PYBIND11_VERSION_PATCH})
message(STATUS "pybind11 v${${PROJECT_NAME}_VERSION}")

if(NOT (CMAKE_VERSION VERSION_LESS 3.0))  # CMake >= 3.0
  # Build an interface library target:
  add_library(module INTERFACE)
  target_include_directories(module INTERFACE $<BUILD_INTERFACE:${PYBIND11_INCLUDE_DIR}>
                                              $<BUILD_INTERFACE:${PYTHON_INCLUDE_DIRS}>
                                              $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
  if(WIN32 OR CYGWIN)
    target_link_libraries(module INTERFACE $<BUILD_INTERFACE:${PYTHON_LIBRARIES}>)
  elseif(APPLE)
    target_link_libraries(module INTERFACE "-undefined dynamic_lookup")
  endif()
  target_compile_options(module INTERFACE $<BUILD_INTERFACE:${PYBIND11_CPP_STANDARD}>)

  add_library(pybind11::module ALIAS module)  # to match exported target
endif()

if (PYBIND11_INSTALL)
  install(FILES ${PYBIND11_HEADERS}
          DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pybind11)
  # GNUInstallDirs "DATADIR" wrong here; CMake search path wants "share".
  set(PYBIND11_CMAKECONFIG_INSTALL_DIR "share/cmake/${PROJECT_NAME}" CACHE STRING "install path for pybind11Config.cmake")

  configure_package_config_file(tools/${PROJECT_NAME}Config.cmake.in
                                "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
                                INSTALL_DESTINATION ${PYBIND11_CMAKECONFIG_INSTALL_DIR})
  write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
                                   VERSION ${${PROJECT_NAME}_VERSION}
                                   COMPATIBILITY AnyNewerVersion)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
                ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
                tools/FindPythonLibsNew.cmake
                tools/pybind11Tools.cmake
          DESTINATION ${PYBIND11_CMAKECONFIG_INSTALL_DIR})

  if(NOT (CMAKE_VERSION VERSION_LESS 3.0))
    install(TARGETS module
            EXPORT "${PROJECT_NAME}Targets")
    install(EXPORT "${PROJECT_NAME}Targets"
            NAMESPACE "${PROJECT_NAME}::"
            DESTINATION ${PYBIND11_CMAKECONFIG_INSTALL_DIR})
  endif()
endif()

## pybind11 2.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,11 @@
 # BSD-style license that can be found in the LICENSE file.
 
 cmake_minimum_required(VERSION 2.8.12)
+
+if (POLICY CMP0048)
+  # cmake warns if loaded from a min-3.0-required parent dir, so silence the warning:
+  cmake_policy(SET CMP0048 NEW)
+endif()
 
 project(pybind11)

=== tests/CMakeLists.txt ===
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting tests build type to MinSizeRel as none was specified")
  set(CMAKE_BUILD_TYPE MinSizeRel CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

# Full set of test files (you can override these; see below)
set(PYBIND11_TEST_FILES
  test_alias_initialization.cpp
  test_buffers.cpp
  test_callbacks.cpp
  test_chrono.cpp
  test_class_args.cpp
  test_constants_and_functions.cpp
  test_copy_move_policies.cpp
  test_docstring_options.cpp
  test_eigen.cpp
  test_enum.cpp
  test_eval.cpp
  test_exceptions.cpp
  test_inheritance.cpp
  test_issues.cpp
  test_keep_alive.cpp
  test_kwargs_and_defaults.cpp
  test_methods_and_attributes.cpp
  test_modules.cpp
  test_multiple_inheritance.cpp
  test_numpy_array.cpp
  test_numpy_dtypes.cpp
  test_numpy_vectorize.cpp
  test_opaque_types.cpp
  test_operator_overloading.cpp
  test_pickling.cpp
  test_python_types.cpp
  test_sequences_and_iterators.cpp
  test_smart_ptr.cpp
  test_stl_binders.cpp
  test_virtual_functions.cpp
)

# Invoking cmake with something like:
#     cmake -DPYBIND11_TEST_OVERRIDE="test_issues.cpp;test_picking.cpp" ..
# lets you override the tests that get compiled and run.  You can restore to all tests with:
#     cmake -DPYBIND11_TEST_OVERRIDE= ..
if (PYBIND11_TEST_OVERRIDE)
  set(PYBIND11_TEST_FILES ${PYBIND11_TEST_OVERRIDE})
endif()

string(REPLACE ".cpp" ".py" PYBIND11_PYTEST_FILES "${PYBIND11_TEST_FILES}")

# Check if Eigen is available; if not, remove from PYBIND11_TEST_FILES (but
# keep it in PYBIND11_PYTEST_FILES, so that we get the "eigen is not installed"
# skip message).
list(FIND PYBIND11_TEST_FILES test_eigen.cpp PYBIND11_TEST_FILES_EIGEN_I)
if(PYBIND11_TEST_FILES_EIGEN_I GREATER -1)
  find_package(Eigen3 QUIET)

  if(EIGEN3_FOUND)
    message(STATUS "Building tests with Eigen v${EIGEN3_VERSION}")
  else()
    list(REMOVE_AT PYBIND11_TEST_FILES ${PYBIND11_TEST_FILES_EIGEN_I})
    message(STATUS "Building tests WITHOUT Eigen")
  endif()
endif()

# Create the binding library
pybind11_add_module(pybind11_tests pybind11_tests.cpp
  ${PYBIND11_TEST_FILES} ${PYBIND11_HEADERS})

pybind11_enable_warnings(pybind11_tests)

if(EIGEN3_FOUND)
  target_include_directories(pybind11_tests PRIVATE ${EIGEN3_INCLUDE_DIR})
  target_compile_definitions(pybind11_tests PRIVATE -DPYBIND11_TEST_EIGEN)
endif()

set(testdir ${PROJECT_SOURCE_DIR}/tests)

# Always write the output file directly into the 'tests' directory (even on MSVC)
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set_target_properties(pybind11_tests PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${testdir})
  foreach(config ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${config} config)
    set_target_properties(pybind11_tests PROPERTIES LIBRARY_OUTPUT_DIRECTORY_${config} ${testdir})
  endforeach()
endif()

# Make sure pytest is found or produce a fatal error
if(NOT PYBIND11_PYTEST_FOUND)
  execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import pytest" OUTPUT_QUIET ERROR_QUIET
                  RESULT_VARIABLE PYBIND11_EXEC_PYTHON_ERR)
  if(PYBIND11_EXEC_PYTHON_ERR)
    message(FATAL_ERROR "Running the tests requires pytest.  Please install it manually (try: ${PYTHON_EXECUTABLE} -m pip install pytest)")
  endif()
  set(PYBIND11_PYTEST_FOUND TRUE CACHE INTERNAL "")
endif()

# A single command to compile and run the tests
add_custom_target(pytest COMMAND ${PYTHON_EXECUTABLE} -m pytest -rws ${PYBIND11_PYTEST_FILES}
                  DEPENDS pybind11_tests WORKING_DIRECTORY ${testdir})

if(PYBIND11_TEST_OVERRIDE)
  add_custom_command(TARGET pytest POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E echo "Note: not all tests run: -DPYBIND11_TEST_OVERRIDE is in effect")
endif()

# And another to show the .so size and, if a previous size, compare it:
add_custom_command(TARGET pybind11_tests POST_BUILD
  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tools/libsize.py
  $<TARGET_FILE:pybind11_tests> ${CMAKE_CURRENT_BINARY_DIR}/sosize-$<TARGET_FILE_NAME:pybind11_tests>.txt)

# Test CMake build using functions and targets from subdirectory or installed location
add_custom_target(test_cmake_build)
if(NOT CMAKE_VERSION VERSION_LESS 3.1)
  # 3.0 needed for interface library for subdirectory_target/installed_target
  # 3.1 needed for cmake -E env for testing

  include(CMakeParseArguments)
  function(pybind11_add_build_test name)
    cmake_parse_arguments(ARG "INSTALL" "" "" ${ARGN})

    set(build_options "-DCMAKE_PREFIX_PATH=${PROJECT_BINARY_DIR}/mock_install"
                      "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
                      "-DPYTHON_EXECUTABLE=${PYTHON_EXECUTABLE}"
                      "-DPYBIND11_CPP_STANDARD=${PYBIND11_CPP_STANDARD}")
    if(NOT ARG_INSTALL)
      list(APPEND build_options "-DPYBIND11_PROJECT_DIR=${PROJECT_SOURCE_DIR}")
    endif()

    add_custom_target(test_${name} ${CMAKE_CTEST_COMMAND}
      --quiet --output-log test_cmake_build/${name}.log
      --build-and-test "${CMAKE_CURRENT_SOURCE_DIR}/test_cmake_build/${name}"
                       "${CMAKE_CURRENT_BINARY_DIR}/test_cmake_build/${name}"
      --build-config Release
      --build-noclean
      --build-generator ${CMAKE_GENERATOR}
      $<$<BOOL:${CMAKE_GENERATOR_PLATFORM}>:--build-generator-platform> ${CMAKE_GENERATOR_PLATFORM}
      --build-makeprogram ${CMAKE_MAKE_PROGRAM}
      --build-target check
      --build-options ${build_options}
    )
    if(ARG_INSTALL)
      add_dependencies(test_${name} mock_install)
    endif()
    add_dependencies(test_cmake_build test_${name})
  endfunction()

  pybind11_add_build_test(subdirectory_function)
  pybind11_add_build_test(subdirectory_target)

  if(PYBIND11_INSTALL)
    add_custom_target(mock_install ${CMAKE_COMMAND}
      "-DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}/mock_install"
      -P "${PROJECT_BINARY_DIR}/cmake_install.cmake"
    )

    pybind11_add_build_test(installed_function INSTALL)
    pybind11_add_build_test(installed_target INSTALL)
  endif()
endif()

# Run all the tests
add_custom_target(check DEPENDS pytest test_cmake_build)

=== tests/test_cmake_build/installed_function/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(test_installed_module CXX)

set(CMAKE_MODULE_PATH "")

find_package(pybind11 CONFIG REQUIRED)
message(STATUS "Found pybind11 v${pybind11_VERSION}: ${pybind11_INCLUDE_DIRS}")

pybind11_add_module(test_cmake_build SHARED NO_EXTRAS ../main.cpp)

add_custom_target(check ${CMAKE_COMMAND} -E env PYTHONPATH=$<TARGET_FILE_DIR:test_cmake_build>
                  ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/../test.py ${PROJECT_NAME})

=== tests/test_cmake_build/installed_target/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(test_installed_target CXX)

set(CMAKE_MODULE_PATH "")

find_package(pybind11 CONFIG REQUIRED)
message(STATUS "Found pybind11 v${pybind11_VERSION}: ${pybind11_INCLUDE_DIRS}")

add_library(test_cmake_build MODULE ../main.cpp)

target_link_libraries(test_cmake_build PRIVATE pybind11::module)

# make sure result is, for example, test_installed_target.so, not libtest_installed_target.dylib
set_target_properties(test_cmake_build PROPERTIES PREFIX "${PYTHON_MODULE_PREFIX}"
                                                  SUFFIX "${PYTHON_MODULE_EXTENSION}")

add_custom_target(check ${CMAKE_COMMAND} -E env PYTHONPATH=$<TARGET_FILE_DIR:test_cmake_build>
                  ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/../test.py ${PROJECT_NAME})

=== debian/changelog ===
pybind11 (2.0.1-4) unstable; urgency=medium

  * Build the tests with the default Python 3 version.
    Thanks to Adrian Bunk (Closes: #867551)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 20 Jul 2017 14:56:01 +0100

pybind11 (2.0.1-3) unstable; urgency=medium

  * Run autopkgtests for all supported Python versions

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 25 Feb 2017 12:11:08 +0000

pybind11 (2.0.1-2) unstable; urgency=medium

  * Fix missing CMake package configuration in -dev package
    - New patch 0002-Arch-indep-CMake-package-configuration.patch
    - Install the missing CMake package configuration
    - Use CMake to build the autopkgtest example tests
    Thanks to Jason Rhinelander for reporting (Closes: #854502)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 23 Feb 2017 13:16:46 +0000

pybind11 (2.0.1-1) unstable; urgency=medium

  * New upstream release
  * Use missing sphinxdoc:Built-Using substitution
  * Fix clean filters to enable repeated builds.
    Thanks to Giovani Ferreira for the review

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 07 Jan 2017 17:36:51 +0000

pybind11 (2.0.0-1) unstable; urgency=medium

  * Remove gbp configuration in favor of git-dpm
  * Mangle upstream development versions
  * New upstream release
  * Add support for the nocheck build profile
    - Add versioned dependency on dpkg-dev
    - Mark build dependencies specific to testing as !nocheck
    - Do not build the test suite if nocheck is requested
  * Add support for the nodoc build profile
    - Mark build dependencies specific to the documentation as !nodoc
    - Add build dependency on sphinx-common for dh_sphinxdoc
    - Do not build the documentation if nodoc is requested

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 03 Jan 2017 15:44:46 +0000

pybind11 (2.0.0~rc1-1) unstable; urgency=medium

  * New upstream release
  * Switch to git-dpm
  * Refresh patch queue
  * Add build dependency on pytest
  * Update HTTP proxy setup to the latest guidelines

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 23 Dec 2016 16:39:46 +0000

pybind11 (1.8.1-2) unstable; urgency=medium

  * Fixup the source package maintainer and uploaders.
    - Move myself to list of uploaders.
    - Set Debian Science as maintainer.
  * Install the upstream changelog.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 02 Dec 2016 11:32:07 +0000

pybind11 (1.8.1-1) unstable; urgency=low

  * Initial release. (Closes: #844597)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 22 Nov 2016 11:43:53 +0000

=== debian/control ===
Source: pybind11
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake (>= 2.8.12),
               debhelper (>= 10),
               dpkg-dev (>= 1.17.14),
               dh-python,
               python-all,
               python-pytest <!nocheck>,
               python-setuptools,
               python-sphinx <!nodoc>,
               python-sphinx-rtd-theme <!nodoc>,
               python3-all,
               python3-dev <!nocheck>,
               python3-pytest <!nocheck>,
               python3-setuptools,
               sphinx-common
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/pybind11.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/pybind11.git
Homepage: https://github.com/pybind/pybind11
X-Python-Version: >= 2.7
X-Python3-Version: >= 3.2

Package: pybind11-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}
Suggests: libeigen3-dev,
          pybind11-doc <!nodoc>
Description: seamless operability between C++11 and Python
 pybind11 is a lightweight header library that exposes C++ types in
 Python and vice versa, mainly to create Python bindings of existing C++
 code. Its goals and syntax are similar to the excellent Boost.Python
 library by David Abrahams: to minimize boilerplate code in traditional
 extension modules by inferring type information using compile-time
 introspection.
 .
 This package provides the header-only library.

Package: pybind11-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for pybind11
 pybind11 is a lightweight header library that exposes C++ types in
 Python and vice versa, mainly to create Python bindings of existing C++
 code. Its goals and syntax are similar to the excellent Boost.Python
 library by David Abrahams: to minimize boilerplate code in traditional
 extension modules by inferring type information using compile-time
 introspection.
 .
 This package provides the documentation.
Build-Profiles: <!nodoc>

Package: python-pybind11
Architecture: all
Multi-Arch: foreign
Section: python
Depends: ${misc:Depends},
         ${python:Depends},
         pybind11-dev (= ${binary:Version})
Description: pybind11 helper module for Python 2
 pybind11 is a lightweight header library that exposes C++ types in
 Python and vice versa, mainly to create Python bindings of existing C++
 code. Its goals and syntax are similar to the excellent Boost.Python
 library by David Abrahams: to minimize boilerplate code in traditional
 extension modules by inferring type information using compile-time
 introspection.
 .
 This package provides pybind11 for Python 2.

Package: python3-pybind11
Architecture: all
Multi-Arch: foreign
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         pybind11-dev (= ${binary:Version})
Description: pybind11 helper module for Python 3
 pybind11 is a lightweight header library that exposes C++ types in
 Python and vice versa, mainly to create Python bindings of existing C++
 code. Its goals and syntax are similar to the excellent Boost.Python
 library by David Abrahams: to minimize boilerplate code in traditional
 extension modules by inferring type information using compile-time
 introspection.
 .
 This package provides pybind11 for Python 3.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

BUILD_OPTIONS = -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/$(shell py3versions -d)
ifneq (,$(findstring nocheck,$(DEB_BUILD_PROFILES)))
BUILD_OPTIONS += -DPYBIND11_TEST:BOOL=OFF
endif

export PYBUILD_NAME = pybind11

%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --buildsystem=pybuild

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

override_dh_auto_build: export http_proxy=127.0.0.1:9
override_dh_auto_build: export https_proxy=127.0.0.1:9
override_dh_auto_build:
	dh_auto_build
	dh_auto_build --buildsystem=pybuild
ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
	PYTHONPATH=. sphinx-build -N -b html docs build/html
endif

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --buildsystem=pybuild

override_dh_installchangelogs:
	dh_installchangelogs docs/changelog.rst

=== debian/tests/control ===
Test-Command: set -e
 ; cp debian/tests/example/* "$AUTOPKGTEST_TMP"
 ; for py in $(pyversions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; cmake -DPYTHON_EXECUTABLE=/usr/bin/$py .
 ; cmake --build .
 ; $py -c "import example; assert(example.add(1, 2) == 3)"
 ; done
Depends: cmake, g++ | c++-compiler, pybind11-dev, python-all-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; cp debian/tests/example/* "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; cmake -DPYTHON_EXECUTABLE=/usr/bin/$py .
 ; cmake --build .
 ; $py -c "import example; assert(example.add(1, 2) == 3)"
 ; done
Depends: cmake, g++ | c++-compiler, pybind11-dev, python3-all-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; for py in $(pyversions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -c "import pybind11; print(pybind11.get_include())"
 ; done
Depends: python-all, python-pybind11

Test-Command: set -e
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -c "import pybind11; print(pybind11.get_include())"
 ; done
Depends: python3-all, python3-pybind11

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/pybind11-$1\.tar\.gz/ \
https://github.com/pybind/pybind11/tags .*/v?(\d\S*)\.tar\.gz

## pybind11 2.2.3

=== debian/changelog ===
pybind11 (2.2.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.2.3

 -- Drew Parsons <dparsons@debian.org>  Sat, 05 May 2018 22:36:18 +0800

pybind11 (2.2.2-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable. Closes: #890364.
  * Standards-Version: 4.1.4

 -- Drew Parsons <dparsons@debian.org>  Fri, 27 Apr 2018 11:29:49 +0800

pybind11 (2.2.2-1) experimental; urgency=medium

  * New upstream version 2.2.2
  * Upgrade watch file to version 4
  * Move Eigen and add Numpy to Recommends
  * Point the VCS URIs to salsa.debian.org
  * Bump the debhelper version to 11
  * Bump the standards version to 4.1.3

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 15 Feb 2018 11:34:31 +0000

pybind11 (2.2.1-1) experimental; urgency=medium

  * New upstream version 2.2.1
  * Drop the patch queue, no longer required
  * Prevent multiple install of headers
  * Add new test dependency on Boost
  * Test query of includes via pybind11
  * Add recommended get-orig-source target
  * Fixup the nocheck and nodoc guards
    - Replace occurrences of findstring with filter
    - Use DEB_BUILD_OPTIONS instead of DEB_BUILD_PROFILES
  * Fixup whitespacing in rules file
  * Drop superfluous dependency on python-pytest
  * Filter egg-info directory with extend-diff-ignore
  * Fixup the Vcs-Browser URI
  * Bump the standards version to 4.1.0
  * Update copyright information and dates.
    Thanks to Herbert Fortes for reviewing

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 16 Sep 2017 17:40:27 +0100

pybind11 (2.1.1-1) experimental; urgency=medium

  * New upstream version 2.1.1
  * Drop numbering of the patch queue
  * Clean the docs using the upstream Makefile
  * Refactor the management of configuration arguments
  * Run tests for optional dependencies (eigen, numpy)
  * Bump standards version to 4.0.0, no changes required

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 20 Jul 2017 16:42:31 +0100

pybind11 (2.1.0-1) experimental; urgency=medium

  * Switch from git-dpm to gbp
  * New upstream version 2.1.0
  * Refresh the patch queue
  * Fixup the Vcs-Browser URI
  * Simplify the rules file
  * Update the packaging of the documentation
    - Use the Python 3 version of Sphinx and the RTD theme
    - Add new dependency on the breathe Sphinx extension
    - Call the upstream Makefile for the documentation
    - Install from and clean the docs build directory
  * Add DEP-8 tests for clang

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 25 Mar 2017 13:35:01 +0000

=== debian/control ===
--- 
+++ 
@@ -4,22 +4,26 @@
 Section: libs
 Priority: optional
 Build-Depends: cmake (>= 2.8.12),
-               debhelper (>= 10),
+               debhelper (>= 11),
                dpkg-dev (>= 1.17.14),
                dh-python,
+               libboost-dev (>= 1.56) <!nocheck>,
+               libeigen3-dev <!nocheck>,
                python-all,
-               python-pytest <!nocheck>,
                python-setuptools,
-               python-sphinx <!nodoc>,
-               python-sphinx-rtd-theme <!nodoc>,
                python3-all,
+               python3-breathe <!nodoc>,
                python3-dev <!nocheck>,
+               python3-numpy <!nocheck>,
                python3-pytest <!nocheck>,
+               python3-scipy <!nocheck>,
                python3-setuptools,
+               python3-sphinx <!nodoc>,
+               python3-sphinx-rtd-theme <!nodoc>,
                sphinx-common
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/pybind11.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/pybind11.git
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/science-team/pybind11
+Vcs-Git: https://salsa.debian.org/science-team/pybind11.git
 Homepage: https://github.com/pybind/pybind11
 X-Python-Version: >= 2.7
 X-Python3-Version: >= 3.2
@@ -29,8 +33,8 @@
 Multi-Arch: foreign
 Section: libdevel
 Depends: ${misc:Depends}
-Suggests: libeigen3-dev,
-          pybind11-doc <!nodoc>
+Recommends: libeigen3-dev
+Suggests: pybind11-doc <!nodoc>
 Description: seamless operability between C++11 and Python
  pybind11 is a lightweight header library that exposes C++ types in
  Python and vice versa, mainly to create Python bindings of existing C++
@@ -66,6 +70,7 @@
 Depends: ${misc:Depends},
          ${python:Depends},
          pybind11-dev (= ${binary:Version})
+Recommends: python-numpy
 Description: pybind11 helper module for Python 2
  pybind11 is a lightweight header library that exposes C++ types in
  Python and vice versa, mainly to create Python bindings of existing C++
@@ -83,6 +88,7 @@
 Depends: ${misc:Depends},
          ${python3:Depends},
          pybind11-dev (= ${binary:Version})
+Recommends: python3-numpy
 Description: pybind11 helper module for Python 3
  pybind11 is a lightweight header library that exposes C++ types in
  Python and vice versa, mainly to create Python bindings of existing C++

## pybind11 2.2.4

=== debian/changelog ===
pybind11 (2.2.4-2) unstable; urgency=medium

  * Team upload.
  * add debian patch ignore_bogus_numpy_ABI_warning.patch to ignore
    "RuntimeWarning: numpy.ufunc size changed, may indicate binary
    incompatibility" during pytest runs, as already done for
    numpy.dtype. Triggered by numpy upgrades when scipy is not built
    against the new numpy, not considered harmful. See discussions at
    https://github.com/numpy/numpy/pull/432
    https://github.com/scipy/scipy/issues/3863
    Closes: #917722.

 -- Drew Parsons <dparsons@debian.org>  Sun, 06 Jan 2019 09:58:56 +0100

pybind11 (2.2.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version.
  * Standards-Version: 4.2.1
  * debian/control: remove ancient-python-version-field
    X-Python-Version, X-Python3-Version

 -- Drew Parsons <dparsons@debian.org>  Sat, 22 Sep 2018 10:26:31 +0800

=== debian/control ===
--- 
+++ 
@@ -21,12 +21,10 @@
                python3-sphinx <!nodoc>,
                python3-sphinx-rtd-theme <!nodoc>,
                sphinx-common
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/science-team/pybind11
 Vcs-Git: https://salsa.debian.org/science-team/pybind11.git
 Homepage: https://github.com/pybind/pybind11
-X-Python-Version: >= 2.7
-X-Python3-Version: >= 3.2
 
 Package: pybind11-dev
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Prevent install of headers by setup.py.
export PYBIND11_USE_CMAKE=1

export PYBUILD_NAME=pybind11

CONFIGURE_ARGS=-DPYBIND11_INSTALL:BOOL=ON
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
CONFIGURE_ARGS+=-DPYBIND11_TEST:BOOL=ON \
	-DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/$(shell py3versions -d)
else
CONFIGURE_ARGS+=-DPYBIND11_TEST:BOOL=OFF
endif

%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --buildsystem=pybuild
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C docs clean
endif

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_ARGS)
	dh_auto_configure --buildsystem=pybuild

override_dh_auto_build: export http_proxy=127.0.0.1:9
override_dh_auto_build: export https_proxy=127.0.0.1:9
override_dh_auto_build:
	dh_auto_build
	dh_auto_build --buildsystem=pybuild
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C docs html
endif

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --buildsystem=pybuild

override_dh_installchangelogs:
	dh_installchangelogs docs/changelog.rst

get-orig-source:
	uscan --download-current-version --force-download --no-symlink

=== debian/tests/control ===
Test-Command: set -e
 ; cp debian/tests/example/* "$AUTOPKGTEST_TMP"
 ; for py in $(pyversions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; CC=gcc CXX=g++ cmake -DPYTHON_EXECUTABLE=/usr/bin/$py .
 ; cmake --build .
 ; $py -c "import example; assert(example.add(1, 2) == 3)"
 ; done
Depends: cmake, g++, pybind11-dev, python-all-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; cp debian/tests/example/* "$AUTOPKGTEST_TMP"
 ; for py in $(pyversions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; CC=clang CXX=clang++ cmake -DPYTHON_EXECUTABLE=/usr/bin/$py .
 ; cmake --build .
 ; $py -c "import example; assert(example.add(1, 2) == 3)"
 ; done
Depends: clang, cmake, pybind11-dev, python-all-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; cp debian/tests/example/* "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; CC=gcc CXX=g++ cmake -DPYTHON_EXECUTABLE=/usr/bin/$py .
 ; cmake --build .
 ; $py -c "import example; assert(example.add(1, 2) == 3)"
 ; done
Depends: cmake, g++, pybind11-dev, python3-all-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; cp debian/tests/example/* "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; CC=clang CXX=clang++ cmake -DPYTHON_EXECUTABLE=/usr/bin/$py .
 ; cmake --build .
 ; $py -c "import example; assert(example.add(1, 2) == 3)"
 ; done
Depends: clang, cmake, pybind11-dev, python3-all-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; for py in $(pyversions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -m pybind11 --includes
 ; done
Depends: python-all, python-pybind11

Test-Command: set -e
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -m pybind11 --includes
 ; done
Depends: python3-all, python3-pybind11

## pybind11 2.3.0

=== tests/CMakeLists.txt ===
# CMakeLists.txt -- Build system for the pybind11 test suite
#
# Copyright (c) 2015 Wenzel Jakob <wenzel@inf.ethz.ch>
#
# All rights reserved. Use of this source code is governed by a
# BSD-style license that can be found in the LICENSE file.

cmake_minimum_required(VERSION 2.8.12)

option(PYBIND11_WERROR  "Report all warnings as errors"  OFF)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    # We're being loaded directly, i.e. not via add_subdirectory, so make this
    # work as its own project and load the pybind11Config to get the tools we need
    project(pybind11_tests CXX)

    find_package(pybind11 REQUIRED CONFIG)
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting tests build type to MinSizeRel as none was specified")
  set(CMAKE_BUILD_TYPE MinSizeRel CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

# Full set of test files (you can override these; see below)
set(PYBIND11_TEST_FILES
  test_buffers.cpp
  test_builtin_casters.cpp
  test_call_policies.cpp
  test_callbacks.cpp
  test_chrono.cpp
  test_class.cpp
  test_constants_and_functions.cpp
  test_copy_move.cpp
  test_docstring_options.cpp
  test_eigen.cpp
  test_enum.cpp
  test_eval.cpp
  test_exceptions.cpp
  test_factory_constructors.cpp
  test_gil_scoped.cpp
  test_iostream.cpp
  test_kwargs_and_defaults.cpp
  test_local_bindings.cpp
  test_methods_and_attributes.cpp
  test_modules.cpp
  test_multiple_inheritance.cpp
  test_numpy_array.cpp
  test_numpy_dtypes.cpp
  test_numpy_vectorize.cpp
  test_opaque_types.cpp
  test_operator_overloading.cpp
  test_pickling.cpp
  test_pytypes.cpp
  test_sequences_and_iterators.cpp
  test_smart_ptr.cpp
  test_stl.cpp
  test_stl_binders.cpp
  test_tagbased_polymorphic.cpp
  test_union.cpp
  test_virtual_functions.cpp
)

# Invoking cmake with something like:
#     cmake -DPYBIND11_TEST_OVERRIDE="test_callbacks.cpp;test_picking.cpp" ..
# lets you override the tests that get compiled and run.  You can restore to all tests with:
#     cmake -DPYBIND11_TEST_OVERRIDE= ..
if (PYBIND11_TEST_OVERRIDE)
  set(PYBIND11_TEST_FILES ${PYBIND11_TEST_OVERRIDE})
endif()

string(REPLACE ".cpp" ".py" PYBIND11_PYTEST_FILES "${PYBIND11_TEST_FILES}")

# Contains the set of test files that require pybind11_cross_module_tests to be
# built; if none of these are built (i.e. because TEST_OVERRIDE is used and
# doesn't include them) the second module doesn't get built.
set(PYBIND11_CROSS_MODULE_TESTS
  test_exceptions.py
  test_local_bindings.py
  test_stl.py
  test_stl_binders.py
)

# Check if Eigen is available; if not, remove from PYBIND11_TEST_FILES (but
# keep it in PYBIND11_PYTEST_FILES, so that we get the "eigen is not installed"
# skip message).
list(FIND PYBIND11_TEST_FILES test_eigen.cpp PYBIND11_TEST_FILES_EIGEN_I)
if(PYBIND11_TEST_FILES_EIGEN_I GREATER -1)
  # Try loading via newer Eigen's Eigen3Config first (bypassing tools/FindEigen3.cmake).
  # Eigen 3.3.1+ exports a cmake 3.0+ target for handling dependency requirements, but also
  # produces a fatal error if loaded from a pre-3.0 cmake.
  if (NOT CMAKE_VERSION VERSION_LESS 3.0)
    find_package(Eigen3 3.2.7 QUIET CONFIG)
    if (EIGEN3_FOUND)
      if (EIGEN3_VERSION_STRING AND NOT EIGEN3_VERSION_STRING VERSION_LESS 3.3.1)
        set(PYBIND11_EIGEN_VIA_TARGET 1)
      endif()
    endif()
  endif()
  if (NOT EIGEN3_FOUND)
    # Couldn't load via target, so fall back to allowing module mode finding, which will pick up
    # tools/FindEigen3.cmake
    find_package(Eigen3 3.2.7 QUIET)
  endif()

  if(EIGEN3_FOUND)
    # Eigen 3.3.1+ cmake sets EIGEN3_VERSION_STRING (and hard codes the version when installed
    # rather than looking it up in the cmake script); older versions, and the
    # tools/FindEigen3.cmake, set EIGEN3_VERSION instead.
    if(NOT EIGEN3_VERSION AND EIGEN3_VERSION_STRING)
      set(EIGEN3_VERSION ${EIGEN3_VERSION_STRING})
    endif()
    message(STATUS "Building tests with Eigen v${EIGEN3_VERSION}")
  else()
    list(REMOVE_AT PYBIND11_TEST_FILES ${PYBIND11_TEST_FILES_EIGEN_I})
    message(STATUS "Building tests WITHOUT Eigen")
  endif()
endif()

# Optional dependency for some tests (boost::variant is only supported with version >= 1.56)
find_package(Boost 1.56)

# Compile with compiler warnings turned on
function(pybind11_enable_warnings target_name)
  if(MSVC)
    target_compile_options(${target_name} PRIVATE /W4)
  elseif(CMAKE_CXX_COMPILER_ID MATCHES "(GNU|Intel|Clang)")
      target_compile_options(${target_name} PRIVATE -Wall -Wextra -Wconversion -Wcast-qual -Wdeprecated)
  endif()

  if(PYBIND11_WERROR)
    if(MSVC)
      target_compile_options(${target_name} PRIVATE /WX)
    elseif(CMAKE_CXX_COMPILER_ID MATCHES "(GNU|Intel|Clang)")
      target_compile_options(${target_name} PRIVATE -Werror)
    endif()
  endif()
endfunction()

set(test_targets pybind11_tests)

# Build pybind11_cross_module_tests if any test_whatever.py are being built that require it
foreach(t ${PYBIND11_CROSS_MODULE_TESTS})
  list(FIND PYBIND11_PYTEST_FILES ${t} i)
  if (i GREATER -1)
    list(APPEND test_targets pybind11_cross_module_tests)
    break()
  endif()
endforeach()

set(testdir ${CMAKE_CURRENT_SOURCE_DIR})
foreach(target ${test_targets})
  set(test_files ${PYBIND11_TEST_FILES})
  if(NOT target STREQUAL "pybind11_tests")
    set(test_files "")
  endif()

  # Create the binding library
  pybind11_add_module(${target} THIN_LTO ${target}.cpp ${test_files} ${PYBIND11_HEADERS})
  pybind11_enable_warnings(${target})

  if(MSVC)
    target_compile_options(${target} PRIVATE /utf-8)
  endif()

  if(EIGEN3_FOUND)
    if (PYBIND11_EIGEN_VIA_TARGET)
      target_link_libraries(${target} PRIVATE Eigen3::Eigen)
    else()
      target_include_directories(${target} PRIVATE ${EIGEN3_INCLUDE_DIR})
    endif()
    target_compile_definitions(${target} PRIVATE -DPYBIND11_TEST_EIGEN)
  endif()

  if(Boost_FOUND)
    target_include_directories(${target} PRIVATE ${Boost_INCLUDE_DIRS})
    target_compile_definitions(${target} PRIVATE -DPYBIND11_TEST_BOOST)
  endif()

  # Always write the output file directly into the 'tests' directory (even on MSVC)
  if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
    set_target_properties(${target} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${testdir})
    foreach(config ${CMAKE_CONFIGURATION_TYPES})
      string(TOUPPER ${config} config)
      set_target_properties(${target} PROPERTIES LIBRARY_OUTPUT_DIRECTORY_${config} ${testdir})
    endforeach()
  endif()
endforeach()

# Make sure pytest is found or produce a fatal error
if(NOT PYBIND11_PYTEST_FOUND)
  execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import pytest; print(pytest.__version__)"
                  RESULT_VARIABLE pytest_not_found OUTPUT_VARIABLE pytest_version ERROR_QUIET)
  if(pytest_not_found)
    message(FATAL_ERROR "Running the tests requires pytest. Please install it manually"
                        " (try: ${PYTHON_EXECUTABLE} -m pip install pytest)")
  elseif(pytest_version VERSION_LESS 3.0)
    message(FATAL_ERROR "Running the tests requires pytest >= 3.0. Found: ${pytest_version}"
                        "Please update it (try: ${PYTHON_EXECUTABLE} -m pip install -U pytest)")
  endif()
  set(PYBIND11_PYTEST_FOUND TRUE CACHE INTERNAL "")
endif()

if(CMAKE_VERSION VERSION_LESS 3.2)
  set(PYBIND11_USES_TERMINAL "")
else()
  set(PYBIND11_USES_TERMINAL "USES_TERMINAL")
endif()

# A single command to compile and run the tests
add_custom_target(pytest COMMAND ${PYTHON_EXECUTABLE} -m pytest ${PYBIND11_PYTEST_FILES}
                  DEPENDS ${test_targets} WORKING_DIRECTORY ${testdir} ${PYBIND11_USES_TERMINAL})

if(PYBIND11_TEST_OVERRIDE)
  add_custom_command(TARGET pytest POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E echo "Note: not all tests run: -DPYBIND11_TEST_OVERRIDE is in effect")
endif()

# Add a check target to run all the tests, starting with pytest (we add dependencies to this below)
add_custom_target(check DEPENDS pytest)

# The remaining tests only apply when being built as part of the pybind11 project, but not if the
# tests are being built independently.
if (NOT PROJECT_NAME STREQUAL "pybind11")
  return()
endif()

# Add a post-build comment to show the primary test suite .so size and, if a previous size, compare it:
add_custom_command(TARGET pybind11_tests POST_BUILD
  COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/tools/libsize.py
  $<TARGET_FILE:pybind11_tests> ${CMAKE_CURRENT_BINARY_DIR}/sosize-$<TARGET_FILE_NAME:pybind11_tests>.txt)

# Test embedding the interpreter. Provides the `cpptest` target.
add_subdirectory(test_embed)

# Test CMake build using functions and targets from subdirectory or installed location
add_subdirectory(test_cmake_build)

=== debian/changelog ===
pybind11 (2.3.0-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.4.0

 -- Drew Parsons <dparsons@debian.org>  Fri, 02 Aug 2019 18:39:50 +0800

pybind11 (2.3.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - applies patch ignore_bogus_numpy_ABI_warning.patch
  * Standards-Version: 4.3.0
  * debhelper compatibility level 12
    Build-Depends: debhelper-compat (= 12)

 -- Drew Parsons <dparsons@debian.org>  Thu, 13 Jun 2019 21:12:54 +1000

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: cmake (>= 2.8.12),
-               debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
+               cmake (>= 2.8.12),
                dpkg-dev (>= 1.17.14),
                dh-python,
                libboost-dev (>= 1.56) <!nocheck>,
@@ -21,7 +21,7 @@
                python3-sphinx <!nodoc>,
                python3-sphinx-rtd-theme <!nodoc>,
                sphinx-common
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/science-team/pybind11
 Vcs-Git: https://salsa.debian.org/science-team/pybind11.git
 Homepage: https://github.com/pybind/pybind11

## pybind11 2.4.3

=== debian/changelog ===
pybind11 (2.4.3-2build2) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:38:17 +0000

pybind11 (2.4.3-2build1) focal; urgency=medium

  * No-change rebuild to generate dependencies on python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Dec 2019 12:52:34 +0000

pybind11 (2.4.3-2) unstable; urgency=medium

  * Team upload.
  * drop python-pybind11 (Python2 is deprecated). Closes: #937389.

 -- Drew Parsons <dparsons@debian.org>  Fri, 15 Nov 2019 14:27:37 +0800

pybind11 (2.4.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Standards-Version: 4.4.1

 -- Drew Parsons <dparsons@debian.org>  Sun, 20 Oct 2019 12:41:47 +0800

pybind11 (2.4.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Tue, 24 Sep 2019 14:14:59 +0800

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,6 @@
                dh-python,
                libboost-dev (>= 1.56) <!nocheck>,
                libeigen3-dev <!nocheck>,
-               python-all,
-               python-setuptools,
                python3-all,
                python3-breathe <!nodoc>,
                python3-dev <!nocheck>,
@@ -21,7 +19,7 @@
                python3-sphinx <!nodoc>,
                python3-sphinx-rtd-theme <!nodoc>,
                sphinx-common
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/science-team/pybind11
 Vcs-Git: https://salsa.debian.org/science-team/pybind11.git
 Homepage: https://github.com/pybind/pybind11
@@ -61,24 +59,6 @@
  This package provides the documentation.
 Build-Profiles: <!nodoc>
 
-Package: python-pybind11
-Architecture: all
-Multi-Arch: foreign
-Section: python
-Depends: ${misc:Depends},
-         ${python:Depends},
-         pybind11-dev (= ${binary:Version})
-Recommends: python-numpy
-Description: pybind11 helper module for Python 2
- pybind11 is a lightweight header library that exposes C++ types in
- Python and vice versa, mainly to create Python bindings of existing C++
- code. Its goals and syntax are similar to the excellent Boost.Python
- library by David Abrahams: to minimize boilerplate code in traditional
- extension modules by inferring type information using compile-time
- introspection.
- .
- This package provides pybind11 for Python 2.
-
 Package: python3-pybind11
 Architecture: all
 Multi-Arch: foreign

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 endif
 
 %:
-	dh $@ --with python2,python3,sphinxdoc --buildsystem=cmake
+	dh $@ --with python3,sphinxdoc --buildsystem=cmake
 
 override_dh_auto_clean:
 	dh_auto_clean

=== debian/tests/control ===
Test-Command: set -e
 ; cp debian/tests/example/* "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; CC=gcc CXX=g++ cmake -DPYTHON_EXECUTABLE=/usr/bin/$py .
 ; cmake --build .
 ; $py -c "import example; assert(example.add(1, 2) == 3)"
 ; done
Depends: cmake, g++, pybind11-dev, python3-all-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; cp debian/tests/example/* "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; CC=clang CXX=clang++ cmake -DPYTHON_EXECUTABLE=/usr/bin/$py .
 ; cmake --build .
 ; $py -c "import example; assert(example.add(1, 2) == 3)"
 ; done
Depends: clang, cmake, pybind11-dev, python3-all-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -m pybind11 --includes
 ; done
Depends: python3-all, python3-pybind11

## pybind11 2.5.0

=== debian/changelog ===
pybind11 (2.5.0-5) unstable; urgency=medium

  * Team upload.
  * debian patch docs_skip_pytypes.patch skips building pytypes docs
    in order to build with sphinx 3.2.1. See upstream Issue #2404.
    Closes: #963659.
  * debhelper compatibility level 13

 -- Drew Parsons <dparsons@debian.org>  Fri, 28 Aug 2020 11:09:42 +0800

pybind11 (2.5.0-4) unstable; urgency=medium

  * Team upload.
  * debian/tests pybind11 tests (pytest) Depends: python3-all-dev

 -- Drew Parsons <dparsons@debian.org>  Wed, 22 Apr 2020 12:07:03 +0800

pybind11 (2.5.0-3) unstable; urgency=medium

  * Team upload.
  * specify compiler (g++) for pybind11 (pytest) tests in debian/tests

 -- Drew Parsons <dparsons@debian.org>  Mon, 20 Apr 2020 10:56:44 +0800

pybind11 (2.5.0-2) unstable; urgency=medium

  * Team upload.
  * upload new upstream version to unstable

 -- Drew Parsons <dparsons@debian.org>  Sun, 19 Apr 2020 10:00:25 +0800

pybind11 (2.5.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * update API in debian test example:
    use PYBIND11_MODULE instead of deprecated PYBIND11_PLUGIN
  * add pybind11 tests to debian/tests with pytest-3
  * Standards-Version: 4.5.0

 -- Drew Parsons <dparsons@debian.org>  Thu, 16 Apr 2020 23:37:30 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake (>= 2.8.12),
                dpkg-dev (>= 1.17.14),
                dh-python,
@@ -19,7 +19,7 @@
                python3-sphinx <!nodoc>,
                python3-sphinx-rtd-theme <!nodoc>,
                sphinx-common
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/science-team/pybind11
 Vcs-Git: https://salsa.debian.org/science-team/pybind11.git
 Homepage: https://github.com/pybind/pybind11

=== debian/tests/control ===
--- 
+++ 
@@ -29,3 +29,19 @@
  ; $py -m pybind11 --includes
  ; done
 Depends: python3-all, python3-pybind11
+
+Test-Command: set -e
+ ; cp -r tests ${AUTOPKGTEST_TMP}
+ ; cd ${AUTOPKGTEST_TMP}/tests
+ ; cmake .
+ ; make
+ ; pytest-3
+Depends: python3-all-dev,
+ python3-pybind11,
+ python3-pytest,
+ python3-numpy,
+ python3-scipy,
+ cmake,
+ g++,
+ libboost-dev,
+ libeigen3-dev
